#!/usr/bin/env python
##################################################
# Gnuradio Python Flow Graph
# Title: Icom PCR1000 control
# Author: UB3TJR
# Generated: Sun Jan 11 12:48:31 2015
##################################################

from gnuradio import eng_notation
from gnuradio import gr
from gnuradio.eng_option import eng_option
from gnuradio.filter import firdes
from gnuradio.wxgui import forms
from grc_gnuradio import wxgui as grc_wxgui
from optparse import OptionParser
import ConfigParser
import wx
import xmlrpclib
import time

class pcrcontrol(grc_wxgui.top_block_gui):

    def __init__(self):
        grc_wxgui.top_block_gui.__init__(self, title="Icom PCR1000 control")
        _icon_path = "/usr/share/icons/hicolor/32x32/apps/gnuradio-grc.png"
        self.SetIcon(wx.Icon(_icon_path, wx.BITMAP_TYPE_ANY))

        ##################################################
        # Variables
        ##################################################
        self._volume_init_config = ConfigParser.ConfigParser()
        self._volume_init_config.read("pcrcontrol.conf")
        try: volume_init = self._volume_init_config.getint("main", "volume")
        except: volume_init = 50
        self.volume_init = volume_init
        self._squelch_init_config = ConfigParser.ConfigParser()
        self._squelch_init_config.read("pcrcontrol.conf")
        try: squelch_init = self._squelch_init_config.getint("main", "squelch")
        except: squelch_init = 0
        self.squelch_init = squelch_init
        self._scan_direction_init_config = ConfigParser.ConfigParser()
        self._scan_direction_init_config.read("pcrcontrol.conf")
        try: scan_direction_init = self._scan_direction_init_config.getint("auto_scan", "scan_direction")
        except: scan_direction_init = 1
        self.scan_direction_init = scan_direction_init
        self._nb_init_config = ConfigParser.ConfigParser()
        self._nb_init_config.read("pcrcontrol.conf")
        try: nb_init = self._nb_init_config.getint("main", "nb")
        except: nb_init = 0
        self.nb_init = nb_init
        self._mhz_to_init_config = ConfigParser.ConfigParser()
        self._mhz_to_init_config.read("pcrcontrol.conf")
        try: mhz_to_init = self._mhz_to_init_config.getint("auto_scan", "mhz_to")
        except: mhz_to_init = 0
        self.mhz_to_init = mhz_to_init
        self._mhz_step_init_config = ConfigParser.ConfigParser()
        self._mhz_step_init_config.read("pcrcontrol.conf")
        try: mhz_step_init = self._mhz_step_init_config.getint("manual_scan", "mhz_step")
        except: mhz_step_init = 0
        self.mhz_step_init = mhz_step_init
        self._mhz_from_init_config = ConfigParser.ConfigParser()
        self._mhz_from_init_config.read("pcrcontrol.conf")
        try: mhz_from_init = self._mhz_from_init_config.getint("auto_scan", "mhz_from")
        except: mhz_from_init = 0
        self.mhz_from_init = mhz_from_init
        self._khz_to_init_config = ConfigParser.ConfigParser()
        self._khz_to_init_config.read("pcrcontrol.conf")
        try: khz_to_init = self._khz_to_init_config.getint("auto_scan", "khz_to")
        except: khz_to_init = 0
        self.khz_to_init = khz_to_init
        self._khz_step_init_config = ConfigParser.ConfigParser()
        self._khz_step_init_config.read("pcrcontrol.conf")
        try: khz_step_init = self._khz_step_init_config.getint("manual_scan", "khz_step")
        except: khz_step_init = 0
        self.khz_step_init = khz_step_init
        self._khz_from_init_config = ConfigParser.ConfigParser()
        self._khz_from_init_config.read("pcrcontrol.conf")
        try: khz_from_init = self._khz_from_init_config.getint("auto_scan", "khz_from")
        except: khz_from_init = 0
        self.khz_from_init = khz_from_init
        self._ifshift_init_config = ConfigParser.ConfigParser()
        self._ifshift_init_config.read("pcrcontrol.conf")
        try: ifshift_init = self._ifshift_init_config.getint("main", "ifshift")
        except: ifshift_init = 0
        self.ifshift_init = ifshift_init
        self._fr_modulation_init_config = ConfigParser.ConfigParser()
        self._fr_modulation_init_config.read("pcrcontrol.conf")
        try: fr_modulation_init = self._fr_modulation_init_config.getint("main", "fr_modulation")
        except: fr_modulation_init = 2
        self.fr_modulation_init = fr_modulation_init
        self._fr_mhz_init_config = ConfigParser.ConfigParser()
        self._fr_mhz_init_config.read("pcrcontrol.conf")
        try: fr_mhz_init = self._fr_mhz_init_config.getint("main", "fr_mhz")
        except: fr_mhz_init = 0
        self.fr_mhz_init = fr_mhz_init
        self._fr_khz_init_config = ConfigParser.ConfigParser()
        self._fr_khz_init_config.read("pcrcontrol.conf")
        try: fr_khz_init = self._fr_khz_init_config.getint("main", "fr_khz")
        except: fr_khz_init = 0
        self.fr_khz_init = fr_khz_init
        self._fr_filter_init_config = ConfigParser.ConfigParser()
        self._fr_filter_init_config.read("pcrcontrol.conf")
        try: fr_filter_init = self._fr_filter_init_config.getint("main", "fr_filter")
        except: fr_filter_init = 3
        self.fr_filter_init = fr_filter_init
        self._auto_step_init_config = ConfigParser.ConfigParser()
        self._auto_step_init_config.read("pcrcontrol.conf")
        try: auto_step_init = self._auto_step_init_config.getint("auto_scan", "auto_step")
        except: auto_step_init = 0
        self.auto_step_init = auto_step_init
        self._at_init_config = ConfigParser.ConfigParser()
        self._at_init_config.read("pcrcontrol.conf")
        try: at_init = self._at_init_config.getint("main", "at")
        except: at_init = 0
        self.at_init = at_init
        self._agc_init_config = ConfigParser.ConfigParser()
        self._agc_init_config.read("pcrcontrol.conf")
        try: agc_init = self._agc_init_config.getint("main", "agc")
        except: agc_init = 0
        self.agc_init = agc_init
        self.volume = volume = volume_init
        self.start_prog_scan = start_prog_scan = 0
        self.start_auto_scan = start_auto_scan = 0
        self.squelch = squelch = squelch_init
        self.scan_direction = scan_direction = scan_direction_init
        self.program_path = program_path = 0
        self.power = power = 0
        self.nb = nb = nb_init
        self.mhz_up = mhz_up = 1
        self.mhz_to = mhz_to = mhz_to_init
        self.mhz_step = mhz_step = mhz_step_init
        self.mhz_from = mhz_from = mhz_from_init
        self.mhz_down = mhz_down = 1
        self.khz_up = khz_up = 1
        self.khz_to = khz_to = khz_to_init
        self.khz_step = khz_step = khz_step_init
        self.khz_from = khz_from = khz_from_init
        self.khz_down = khz_down = 1
        self.ifshift = ifshift = ifshift_init
        self.fr_modulation = fr_modulation = fr_modulation_init
        self.fr_mhz = fr_mhz = fr_mhz_init
        self.fr_khz = fr_khz = fr_khz_init
        self.fr_filter = fr_filter = fr_filter_init
        self.auto_step = auto_step = auto_step_init
        self.at = at = at_init
        self.agc = agc = agc_init

        ##################################################
        # Blocks
        ##################################################
        self.notebook_scan = self.notebook_scan = wx.Notebook(self.GetWin(), style=wx.NB_TOP)
        self.notebook_scan.AddPage(grc_wxgui.Panel(self.notebook_scan), "Manual")
        self.notebook_scan.AddPage(grc_wxgui.Panel(self.notebook_scan), "Auto")
        self.notebook_scan.AddPage(grc_wxgui.Panel(self.notebook_scan), "Programmable")
        self.GridAdd(self.notebook_scan, 2, 6, 3, 5)
        self.xmlrpc_client_9 = xmlrpclib.Server('http://localhost:8088')
        self.xmlrpc_client_8 = xmlrpclib.Server('http://localhost:8088')
        self.xmlrpc_client_7 = xmlrpclib.Server('http://localhost:8088')
        self.xmlrpc_client_6 = xmlrpclib.Server('http://localhost:8088')
        self.xmlrpc_client_5 = xmlrpclib.Server('http://localhost:8088')
        self.xmlrpc_client_4 = xmlrpclib.Server('http://localhost:8088')
        self.xmlrpc_client_3 = xmlrpclib.Server('http://localhost:8088')
        self.xmlrpc_client_2 = xmlrpclib.Server('http://localhost:8088')
        self.xmlrpc_client_10 = xmlrpclib.Server('http://localhost:8088')
        self.xmlrpc_client_1 = xmlrpclib.Server('http://localhost:8088')
        self.xmlrpc_client_0 = xmlrpclib.Server('http://localhost:8088')
        _volume_sizer = wx.BoxSizer(wx.VERTICAL)
        self._volume_text_box = forms.text_box(
        	parent=self.GetWin(),
        	sizer=_volume_sizer,
        	value=self.volume,
        	callback=self.set_volume,
        	label="Volume",
        	converter=forms.int_converter(),
        	proportion=0,
        )
        self._volume_slider = forms.slider(
        	parent=self.GetWin(),
        	sizer=_volume_sizer,
        	value=self.volume,
        	callback=self.set_volume,
        	minimum=0,
        	maximum=255,
        	num_steps=255,
        	style=wx.SL_HORIZONTAL,
        	cast=int,
        	proportion=1,
        )
        self.GridAdd(_volume_sizer, 0, 2, 1, 3)
        self._start_prog_scan_chooser = forms.button(
        	parent=self.notebook_scan.GetPage(2).GetWin(),
        	value=self.start_prog_scan,
        	callback=self.set_start_prog_scan,
        	label=" ",
        	choices=[0,1],
        	labels=['Start program scan', 'Stop program scan'],
        )
        self.notebook_scan.GetPage(2).GridAdd(self._start_prog_scan_chooser, 1, 0, 1, 5)
        self._start_auto_scan_chooser = forms.button(
        	parent=self.notebook_scan.GetPage(1).GetWin(),
        	value=self.start_auto_scan,
        	callback=self.set_start_auto_scan,
        	label=" ",
        	choices=[0,1],
        	labels=['Start scan', 'Stop scan'],
        )
        self.notebook_scan.GetPage(1).GridAdd(self._start_auto_scan_chooser, 2, 1, 2, 2)
        _squelch_sizer = wx.BoxSizer(wx.VERTICAL)
        self._squelch_text_box = forms.text_box(
        	parent=self.GetWin(),
        	sizer=_squelch_sizer,
        	value=self.squelch,
        	callback=self.set_squelch,
        	label="Squelch",
        	converter=forms.int_converter(),
        	proportion=0,
        )
        self._squelch_slider = forms.slider(
        	parent=self.GetWin(),
        	sizer=_squelch_sizer,
        	value=self.squelch,
        	callback=self.set_squelch,
        	minimum=0,
        	maximum=255,
        	num_steps=255,
        	style=wx.SL_HORIZONTAL,
        	cast=int,
        	proportion=1,
        )
        self.GridAdd(_squelch_sizer, 1, 0, 1, 1)
        self._scan_direction_chooser = forms.drop_down(
        	parent=self.notebook_scan.GetPage(1).GetWin(),
        	value=self.scan_direction,
        	callback=self.set_scan_direction,
        	label="Scan to",
        	choices=[1, 2, 3],
        	labels=['Up', 'Down', 'Up/Down'],
        )
        self.notebook_scan.GetPage(1).GridAdd(self._scan_direction_chooser, 3, 0, 1, 1)
        self._program_path_text_box = forms.text_box(
        	parent=self.notebook_scan.GetPage(2).GetWin(),
        	value=self.program_path,
        	callback=self.set_program_path,
        	label="Path to program",
        	converter=forms.str_converter(),
        )
        self.notebook_scan.GetPage(2).GridAdd(self._program_path_text_box, 0, 0, 1, 5)
        self._power_chooser = forms.button(
        	parent=self.GetWin(),
        	value=self.power,
        	callback=self.set_power,
        	label=" ",
        	choices=[0,1],
        	labels=['Power off', 'Power on'],
        )
        self.GridAdd(self._power_chooser, 0, 6, 1, 1)
        self._nb_chooser = forms.button(
        	parent=self.GetWin(),
        	value=self.nb,
        	callback=self.set_nb,
        	label=" ",
        	choices=[0,1],
        	labels=['Noise blanker off', 'Noise blanker on'],
        )
        self.GridAdd(self._nb_chooser, 2, 1, 1, 1)
        self._mhz_up_chooser = forms.button(
        	parent=self.notebook_scan.GetPage(0).GetWin(),
        	value=self.mhz_up,
        	callback=self.set_mhz_up,
        	label=" ",
        	choices=[0, 1],
        	labels=['+','+'],
        )
        self.notebook_scan.GetPage(0).GridAdd(self._mhz_up_chooser, 0, 1, 1, 1)
        self._mhz_to_text_box = forms.text_box(
        	parent=self.notebook_scan.GetPage(1).GetWin(),
        	value=self.mhz_to,
        	callback=self.set_mhz_to,
        	label="To, Mhz    ",
        	converter=forms.int_converter(),
        )
        self.notebook_scan.GetPage(1).GridAdd(self._mhz_to_text_box, 1, 0, 1, 1)
        self._mhz_step_chooser = forms.drop_down(
        	parent=self.notebook_scan.GetPage(0).GetWin(),
        	value=self.mhz_step,
        	callback=self.set_mhz_step,
        	label="Mhz step",
        	choices=[0, 1, 2, 3, 6, 15, 30],
        	labels=[0, 1, 2, 3, 6, 15, 30],
        )
        self.notebook_scan.GetPage(0).GridAdd(self._mhz_step_chooser, 0, 0, 1, 1)
        self._mhz_from_text_box = forms.text_box(
        	parent=self.notebook_scan.GetPage(1).GetWin(),
        	value=self.mhz_from,
        	callback=self.set_mhz_from,
        	label="From, Mhz",
        	converter=forms.int_converter(),
        )
        self.notebook_scan.GetPage(1).GridAdd(self._mhz_from_text_box, 0, 0, 1, 1)
        self._mhz_down_chooser = forms.button(
        	parent=self.notebook_scan.GetPage(0).GetWin(),
        	value=self.mhz_down,
        	callback=self.set_mhz_down,
        	label=" ",
        	choices=[0, 1],
        	labels=['-','-'],
        )
        self.notebook_scan.GetPage(0).GridAdd(self._mhz_down_chooser, 0, 2, 1, 1)
        self._khz_up_chooser = forms.button(
        	parent=self.notebook_scan.GetPage(0).GetWin(),
        	value=self.khz_up,
        	callback=self.set_khz_up,
        	label=" ",
        	choices=[0, 1],
        	labels=['+','+'],
        )
        self.notebook_scan.GetPage(0).GridAdd(self._khz_up_chooser, 1, 1, 1, 1)
        self._khz_to_text_box = forms.text_box(
        	parent=self.notebook_scan.GetPage(1).GetWin(),
        	value=self.khz_to,
        	callback=self.set_khz_to,
        	label="To, Khz    ",
        	converter=forms.int_converter(),
        )
        self.notebook_scan.GetPage(1).GridAdd(self._khz_to_text_box, 1, 1, 1, 1)
        self._khz_step_chooser = forms.drop_down(
        	parent=self.notebook_scan.GetPage(0).GetWin(),
        	value=self.khz_step,
        	callback=self.set_khz_step,
        	label="Khz step",
        	choices=[0, 1, 2, 3, 5, 6, 10, 15, 30, 50, 100],
        	labels=[0, 1, 2, 3, 5, 6, 10, 15, 30, 50, 100],
        )
        self.notebook_scan.GetPage(0).GridAdd(self._khz_step_chooser, 1, 0, 1, 1)
        self._khz_from_text_box = forms.text_box(
        	parent=self.notebook_scan.GetPage(1).GetWin(),
        	value=self.khz_from,
        	callback=self.set_khz_from,
        	label="From, Khz",
        	converter=forms.int_converter(),
        )
        self.notebook_scan.GetPage(1).GridAdd(self._khz_from_text_box, 0, 1, 1, 1)
        self._khz_down_chooser = forms.button(
        	parent=self.notebook_scan.GetPage(0).GetWin(),
        	value=self.khz_down,
        	callback=self.set_khz_down,
        	label=" ",
        	choices=[0, 1],
        	labels=['-','-'],
        )
        self.notebook_scan.GetPage(0).GridAdd(self._khz_down_chooser, 1, 2, 1, 1)
        _ifshift_sizer = wx.BoxSizer(wx.VERTICAL)
        self._ifshift_text_box = forms.text_box(
        	parent=self.GetWin(),
        	sizer=_ifshift_sizer,
        	value=self.ifshift,
        	callback=self.set_ifshift,
        	label="IF Shift",
        	converter=forms.int_converter(),
        	proportion=0,
        )
        self._ifshift_slider = forms.slider(
        	parent=self.GetWin(),
        	sizer=_ifshift_sizer,
        	value=self.ifshift,
        	callback=self.set_ifshift,
        	minimum=0,
        	maximum=255,
        	num_steps=255,
        	style=wx.SL_HORIZONTAL,
        	cast=int,
        	proportion=1,
        )
        self.GridAdd(_ifshift_sizer, 1, 1, 1, 1)
        self._fr_modulation_chooser = forms.drop_down(
        	parent=self.GetWin(),
        	value=self.fr_modulation,
        	callback=self.set_fr_modulation,
        	label="Modulation",
        	choices=[0, 1, 2, 3, 5, 6],
        	labels=['LSB', 'USB', 'AM', 'CW', 'NFM', 'WBFM'],
        )
        self.GridAdd(self._fr_modulation_chooser, 0, 0, 1, 1)
        _fr_mhz_sizer = wx.BoxSizer(wx.VERTICAL)
        self._fr_mhz_text_box = forms.text_box(
        	parent=self.GetWin(),
        	sizer=_fr_mhz_sizer,
        	value=self.fr_mhz,
        	callback=self.set_fr_mhz,
        	label="MHz",
        	converter=forms.int_converter(),
        	proportion=0,
        )
        self._fr_mhz_slider = forms.slider(
        	parent=self.GetWin(),
        	sizer=_fr_mhz_sizer,
        	value=self.fr_mhz,
        	callback=self.set_fr_mhz,
        	minimum=0,
        	maximum=999,
        	num_steps=999,
        	style=wx.SL_HORIZONTAL,
        	cast=int,
        	proportion=1,
        )
        self.GridAdd(_fr_mhz_sizer, 3, 0, 1, 6)
        _fr_khz_sizer = wx.BoxSizer(wx.VERTICAL)
        self._fr_khz_text_box = forms.text_box(
        	parent=self.GetWin(),
        	sizer=_fr_khz_sizer,
        	value=self.fr_khz,
        	callback=self.set_fr_khz,
        	label="Khz",
        	converter=forms.int_converter(),
        	proportion=0,
        )
        self._fr_khz_slider = forms.slider(
        	parent=self.GetWin(),
        	sizer=_fr_khz_sizer,
        	value=self.fr_khz,
        	callback=self.set_fr_khz,
        	minimum=0,
        	maximum=999,
        	num_steps=999,
        	style=wx.SL_HORIZONTAL,
        	cast=int,
        	proportion=1,
        )
        self.GridAdd(_fr_khz_sizer, 4, 0, 1, 6)
        self._fr_filter_chooser = forms.drop_down(
        	parent=self.GetWin(),
        	value=self.fr_filter,
        	callback=self.set_fr_filter,
        	label="Filter width",
        	choices=[0, 1, 2, 3, 4],
        	labels=['3 kHz', '6 kHz', '15 kHz', '50 kHz', '230 kHz'],
        )
        self.GridAdd(self._fr_filter_chooser, 0, 1, 1, 1)
        self._auto_step_text_box = forms.text_box(
        	parent=self.notebook_scan.GetPage(1).GetWin(),
        	value=self.auto_step,
        	callback=self.set_auto_step,
        	label="Step, Khz",
        	converter=forms.int_converter(),
        )
        self.notebook_scan.GetPage(1).GridAdd(self._auto_step_text_box, 2, 0, 1, 1)
        self._at_chooser = forms.button(
        	parent=self.GetWin(),
        	value=self.at,
        	callback=self.set_at,
        	label=" ",
        	choices=[0,1],
        	labels=['Attenuator Off', 'Attenuator On'],
        )
        self.GridAdd(self._at_chooser, 2, 2, 1, 1)
        self._agc_chooser = forms.button(
        	parent=self.GetWin(),
        	value=self.agc,
        	callback=self.set_agc,
        	label=" ",
        	choices=[0,1],
        	labels=['AGC off', 'AGC on'],
        )
        self.GridAdd(self._agc_chooser, 2, 0, 1, 1)


# QT sink close method reimplementation

    def get_volume_init(self):
        return self.volume_init

    def set_volume_init(self, volume_init):
        self.volume_init = volume_init
        self.set_volume(self.volume_init)

    def get_squelch_init(self):
        return self.squelch_init

    def set_squelch_init(self, squelch_init):
        self.squelch_init = squelch_init
        self.set_squelch(self.squelch_init)

    def get_scan_direction_init(self):
        return self.scan_direction_init

    def set_scan_direction_init(self, scan_direction_init):
        self.scan_direction_init = scan_direction_init
        self.set_scan_direction(self.scan_direction_init)

    def get_nb_init(self):
        return self.nb_init

    def set_nb_init(self, nb_init):
        self.nb_init = nb_init
        self.set_nb(self.nb_init)

    def get_mhz_to_init(self):
        return self.mhz_to_init

    def set_mhz_to_init(self, mhz_to_init):
        self.mhz_to_init = mhz_to_init
        self.set_mhz_to(self.mhz_to_init)

    def get_mhz_step_init(self):
        return self.mhz_step_init

    def set_mhz_step_init(self, mhz_step_init):
        self.mhz_step_init = mhz_step_init
        self.set_mhz_step(self.mhz_step_init)

    def get_mhz_from_init(self):
        return self.mhz_from_init

    def set_mhz_from_init(self, mhz_from_init):
        self.mhz_from_init = mhz_from_init
        self.set_mhz_from(self.mhz_from_init)

    def get_khz_to_init(self):
        return self.khz_to_init

    def set_khz_to_init(self, khz_to_init):
        self.khz_to_init = khz_to_init
        self.set_khz_to(self.khz_to_init)

    def get_khz_step_init(self):
        return self.khz_step_init

    def set_khz_step_init(self, khz_step_init):
        self.khz_step_init = khz_step_init
        self.set_khz_step(self.khz_step_init)

    def get_khz_from_init(self):
        return self.khz_from_init

    def set_khz_from_init(self, khz_from_init):
        self.khz_from_init = khz_from_init
        self.set_khz_from(self.khz_from_init)

    def get_ifshift_init(self):
        return self.ifshift_init

    def set_ifshift_init(self, ifshift_init):
        self.ifshift_init = ifshift_init
        self.set_ifshift(self.ifshift_init)

    def get_fr_modulation_init(self):
        return self.fr_modulation_init

    def set_fr_modulation_init(self, fr_modulation_init):
        self.fr_modulation_init = fr_modulation_init
        self.set_fr_modulation(self.fr_modulation_init)

    def get_fr_mhz_init(self):
        return self.fr_mhz_init

    def set_fr_mhz_init(self, fr_mhz_init):
        self.fr_mhz_init = fr_mhz_init
        self.set_fr_mhz(self.fr_mhz_init)

    def get_fr_khz_init(self):
        return self.fr_khz_init

    def set_fr_khz_init(self, fr_khz_init):
        self.fr_khz_init = fr_khz_init
        self.set_fr_khz(self.fr_khz_init)

    def get_fr_filter_init(self):
        return self.fr_filter_init

    def set_fr_filter_init(self, fr_filter_init):
        self.fr_filter_init = fr_filter_init
        self.set_fr_filter(self.fr_filter_init)

    def get_auto_step_init(self):
        return self.auto_step_init

    def set_auto_step_init(self, auto_step_init):
        self.auto_step_init = auto_step_init
        self.set_auto_step(self.auto_step_init)

    def get_at_init(self):
        return self.at_init

    def set_at_init(self, at_init):
        self.at_init = at_init
        self.set_at(self.at_init)

    def get_agc_init(self):
        return self.agc_init

    def set_agc_init(self, agc_init):
        self.agc_init = agc_init
        self.set_agc(self.agc_init)

    def get_volume(self):
        return self.volume

    def set_volume(self, volume):
        self.volume = volume
        self.xmlrpc_client_4.set_volume(self.volume)
        self._volume_init_config = ConfigParser.ConfigParser()
        self._volume_init_config.read("pcrcontrol.conf")
        if not self._volume_init_config.has_section("main"):
        	self._volume_init_config.add_section("main")
        self._volume_init_config.set("main", "volume", str(self.volume))
        self._volume_init_config.write(open("pcrcontrol.conf", 'w'))
        self._volume_slider.set_value(self.volume)
        self._volume_text_box.set_value(self.volume)

    def get_start_prog_scan(self):
        return self.start_prog_scan

    def set_start_prog_scan(self, start_prog_scan):
        self.start_prog_scan = start_prog_scan
        self._start_prog_scan_chooser.set_value(self.start_prog_scan)

    def get_start_auto_scan(self):
        return self.start_auto_scan

    def set_start_auto_scan(self, start_auto_scan):
        self.start_auto_scan = start_auto_scan
        self._start_auto_scan_chooser.set_value(self.start_auto_scan)

    def get_squelch(self):
        return self.squelch

    def set_squelch(self, squelch):
        self.squelch = squelch
        self.xmlrpc_client_6.set_squelch(self.squelch)
        self._squelch_init_config = ConfigParser.ConfigParser()
        self._squelch_init_config.read("pcrcontrol.conf")
        if not self._squelch_init_config.has_section("main"):
        	self._squelch_init_config.add_section("main")
        self._squelch_init_config.set("main", "squelch", str(self.squelch))
        self._squelch_init_config.write(open("pcrcontrol.conf", 'w'))
        self._squelch_slider.set_value(self.squelch)
        self._squelch_text_box.set_value(self.squelch)

    def get_scan_direction(self):
        return self.scan_direction

    def set_scan_direction(self, scan_direction):
        self.scan_direction = scan_direction
        self._scan_direction_init_config = ConfigParser.ConfigParser()
        self._scan_direction_init_config.read("pcrcontrol.conf")
        if not self._scan_direction_init_config.has_section("auto_scan"):
        	self._scan_direction_init_config.add_section("auto_scan")
        self._scan_direction_init_config.set("auto_scan", "scan_direction", str(self.scan_direction))
        self._scan_direction_init_config.write(open("pcrcontrol.conf", 'w'))
        self._scan_direction_chooser.set_value(self.scan_direction)

    def get_program_path(self):
        return self.program_path

    def set_program_path(self, program_path):
        self.program_path = program_path
        self._program_path_text_box.set_value(self.program_path)

    def get_power(self):
        return self.power

    def set_power(self, power):
        self.power = power
        self.xmlrpc_client_5.set_power(self.power)
        self.xmlrpc_client_0.set_fr_mhz(self.get_fr_mhz())
        self.xmlrpc_client_1.set_fr_khz(self.get_fr_khz())
        self.xmlrpc_client_2.set_fr_modulation(self.get_fr_modulation())
        self.xmlrpc_client_3.set_fr_filter(self.get_fr_filter())
	time.sleep(1)
        self.xmlrpc_client_4.set_volume(self.get_volume())
        self.xmlrpc_client_6.set_squelch(self.get_squelch())
        self.xmlrpc_client_7.set_ifshift(self.get_ifshift())
        self.xmlrpc_client_8.set_agc(self.get_agc())
        self.xmlrpc_client_9.set_nb(self.get_nb())
        self.xmlrpc_client_10.set_at(self.get_at())
        self._power_chooser.set_value(self.power)

    def get_nb(self):
        return self.nb

    def set_nb(self, nb):
        self.nb = nb
        self.xmlrpc_client_9.set_nb(self.nb)
        self._nb_init_config = ConfigParser.ConfigParser()
        self._nb_init_config.read("pcrcontrol.conf")
        if not self._nb_init_config.has_section("main"):
        	self._nb_init_config.add_section("main")
        self._nb_init_config.set("main", "nb", str(self.nb))
        self._nb_init_config.write(open("pcrcontrol.conf", 'w'))
        self._nb_chooser.set_value(self.nb)

    def get_mhz_up(self):
        return self.mhz_up

    def set_mhz_up(self, mhz_up):	#Mhz up button
        self.mhz_up = mhz_up
        self._mhz_up_chooser.set_value(self.mhz_up)
        self.set_fr_mhz(self.get_fr_mhz() + self.get_mhz_step())

    def get_mhz_to(self):
        return self.mhz_to

    def set_mhz_to(self, mhz_to):
        self.mhz_to = mhz_to
        self._mhz_to_init_config = ConfigParser.ConfigParser()
        self._mhz_to_init_config.read("pcrcontrol.conf")
        if not self._mhz_to_init_config.has_section("auto_scan"):
        	self._mhz_to_init_config.add_section("auto_scan")
        self._mhz_to_init_config.set("auto_scan", "mhz_to", str(self.mhz_to))
        self._mhz_to_init_config.write(open("pcrcontrol.conf", 'w'))
        self._mhz_to_text_box.set_value(self.mhz_to)

    def get_mhz_step(self):
        return self.mhz_step

    def set_mhz_step(self, mhz_step):
        self.mhz_step = mhz_step
        self._mhz_step_init_config = ConfigParser.ConfigParser()
        self._mhz_step_init_config.read("pcrcontrol.conf")
        if not self._mhz_step_init_config.has_section("manual_scan"):
        	self._mhz_step_init_config.add_section("manual_scan")
        self._mhz_step_init_config.set("manual_scan", "mhz_step", str(self.mhz_step))
        self._mhz_step_init_config.write(open("pcrcontrol.conf", 'w'))
        self._mhz_step_chooser.set_value(self.mhz_step)

    def get_mhz_from(self):
        return self.mhz_from

    def set_mhz_from(self, mhz_from):
        self.mhz_from = mhz_from
        self._mhz_from_init_config = ConfigParser.ConfigParser()
        self._mhz_from_init_config.read("pcrcontrol.conf")
        if not self._mhz_from_init_config.has_section("auto_scan"):
        	self._mhz_from_init_config.add_section("auto_scan")
        self._mhz_from_init_config.set("auto_scan", "mhz_from", str(self.mhz_from))
        self._mhz_from_init_config.write(open("pcrcontrol.conf", 'w'))
        self._mhz_from_text_box.set_value(self.mhz_from)

    def get_mhz_down(self):
        return self.mhz_down

    def set_mhz_down(self, mhz_down):	#Mhz down button
        self.mhz_down = mhz_down
        self._mhz_down_chooser.set_value(self.mhz_down)
        self.set_fr_mhz(self.get_fr_mhz() - self.get_mhz_step())

    def get_khz_up(self):
        return self.khz_up

    def set_khz_up(self, khz_up):	#KHz uo button
        self.khz_up = khz_up
        self._khz_up_chooser.set_value(self.khz_up)
        self.set_fr_khz(self.get_fr_khz() + self.get_khz_step())

    def get_khz_to(self):
        return self.khz_to

    def set_khz_to(self, khz_to):
        self.khz_to = khz_to
        self._khz_to_init_config = ConfigParser.ConfigParser()
        self._khz_to_init_config.read("pcrcontrol.conf")
        if not self._khz_to_init_config.has_section("auto_scan"):
        	self._khz_to_init_config.add_section("auto_scan")
        self._khz_to_init_config.set("auto_scan", "khz_to", str(self.khz_to))
        self._khz_to_init_config.write(open("pcrcontrol.conf", 'w'))
        self._khz_to_text_box.set_value(self.khz_to)

    def get_khz_step(self):
        return self.khz_step

    def set_khz_step(self, khz_step):
        self.khz_step = khz_step
        self._khz_step_init_config = ConfigParser.ConfigParser()
        self._khz_step_init_config.read("pcrcontrol.conf")
        if not self._khz_step_init_config.has_section("manual_scan"):
        	self._khz_step_init_config.add_section("manual_scan")
        self._khz_step_init_config.set("manual_scan", "khz_step", str(self.khz_step))
        self._khz_step_init_config.write(open("pcrcontrol.conf", 'w'))
        self._khz_step_chooser.set_value(self.khz_step)

    def get_khz_from(self):
        return self.khz_from

    def set_khz_from(self, khz_from):
        self.khz_from = khz_from
        self._khz_from_init_config = ConfigParser.ConfigParser()
        self._khz_from_init_config.read("pcrcontrol.conf")
        if not self._khz_from_init_config.has_section("auto_scan"):
        	self._khz_from_init_config.add_section("auto_scan")
        self._khz_from_init_config.set("auto_scan", "khz_from", str(self.khz_from))
        self._khz_from_init_config.write(open("pcrcontrol.conf", 'w'))
        self._khz_from_text_box.set_value(self.khz_from)

    def get_khz_down(self):
        return self.khz_down

    def set_khz_down(self, khz_down):	#Khz down button
        self.khz_down = khz_down
        self._khz_down_chooser.set_value(self.khz_down)
        self.set_fr_khz(self.get_fr_khz() - self.get_khz_step())

    def get_ifshift(self):
        return self.ifshift

    def set_ifshift(self, ifshift):
        self.ifshift = ifshift
        self.xmlrpc_client_7.set_ifshift(self.ifshift)
        self._ifshift_init_config = ConfigParser.ConfigParser()
        self._ifshift_init_config.read("pcrcontrol.conf")
        if not self._ifshift_init_config.has_section("main"):
        	self._ifshift_init_config.add_section("main")
        self._ifshift_init_config.set("main", "ifshift", str(self.ifshift))
        self._ifshift_init_config.write(open("pcrcontrol.conf", 'w'))
        self._ifshift_slider.set_value(self.ifshift)
        self._ifshift_text_box.set_value(self.ifshift)

    def get_fr_modulation(self):
        return self.fr_modulation

    def set_fr_modulation(self, fr_modulation):
        self.fr_modulation = fr_modulation
        self.xmlrpc_client_2.set_fr_modulation(self.fr_modulation)
        self._fr_modulation_init_config = ConfigParser.ConfigParser()
        self._fr_modulation_init_config.read("pcrcontrol.conf")
        if not self._fr_modulation_init_config.has_section("main"):
        	self._fr_modulation_init_config.add_section("main")
        self._fr_modulation_init_config.set("main", "fr_modulation", str(self.fr_modulation))
        self._fr_modulation_init_config.write(open("pcrcontrol.conf", 'w'))
        self._fr_modulation_chooser.set_value(self.fr_modulation)

    def get_fr_mhz(self):
        return self.fr_mhz

    def set_fr_mhz(self, fr_mhz):	#Mhz slider
        if fr_mhz > 999:
	    fr_mhz = 0
        elif fr_mhz < 0:
	    fr_mhz = 999
        self.fr_mhz = fr_mhz
        self.xmlrpc_client_0.set_fr_mhz(self.fr_mhz)
        self._fr_mhz_init_config = ConfigParser.ConfigParser()
        self._fr_mhz_init_config.read("pcrcontrol.conf")
        if not self._fr_mhz_init_config.has_section("main"):
        	self._fr_mhz_init_config.add_section("main")
        self._fr_mhz_init_config.set("main", "fr_mhz", str(self.fr_mhz))
        self._fr_mhz_init_config.write(open("pcrcontrol.conf", 'w'))
        self._fr_mhz_slider.set_value(self.fr_mhz)
        self._fr_mhz_text_box.set_value(self.fr_mhz)

    def get_fr_khz(self):
        return self.fr_khz

    def set_fr_khz(self, fr_khz):	#Khz slider
        if fr_khz > 999:
		fr_khz =0
		self.set_fr_mhz(self.get_fr_mhz() + 1)
        elif fr_khz < 0:
		fr_khz = 999
		self.set_fr_mhz(self.get_fr_mhz() - 1)
        self.fr_khz = fr_khz
        self.xmlrpc_client_1.set_fr_khz(self.fr_khz)
        self._fr_khz_init_config = ConfigParser.ConfigParser()
        self._fr_khz_init_config.read("pcrcontrol.conf")
        if not self._fr_khz_init_config.has_section("main"):
        	self._fr_khz_init_config.add_section("main")
        self._fr_khz_init_config.set("main", "fr_khz", str(self.fr_khz))
        self._fr_khz_init_config.write(open("pcrcontrol.conf", 'w'))
        self._fr_khz_slider.set_value(self.fr_khz)
        self._fr_khz_text_box.set_value(self.fr_khz)

    def get_fr_filter(self):
        return self.fr_filter

    def set_fr_filter(self, fr_filter):
        self.fr_filter = fr_filter
        self.xmlrpc_client_3.set_fr_filter(self.fr_filter)
        self._fr_filter_init_config = ConfigParser.ConfigParser()
        self._fr_filter_init_config.read("pcrcontrol.conf")
        if not self._fr_filter_init_config.has_section("main"):
        	self._fr_filter_init_config.add_section("main")
        self._fr_filter_init_config.set("main", "fr_filter", str(self.fr_filter))
        self._fr_filter_init_config.write(open("pcrcontrol.conf", 'w'))
        self._fr_filter_chooser.set_value(self.fr_filter)

    def get_auto_step(self):
        return self.auto_step

    def set_auto_step(self, auto_step):
        self.auto_step = auto_step
        self._auto_step_init_config = ConfigParser.ConfigParser()
        self._auto_step_init_config.read("pcrcontrol.conf")
        if not self._auto_step_init_config.has_section("auto_scan"):
        	self._auto_step_init_config.add_section("auto_scan")
        self._auto_step_init_config.set("auto_scan", "auto_step", str(self.auto_step))
        self._auto_step_init_config.write(open("pcrcontrol.conf", 'w'))
        self._auto_step_text_box.set_value(self.auto_step)

    def get_at(self):
        return self.at

    def set_at(self, at):
        self.at = at
        self.xmlrpc_client_10.set_at(self.at)
        self._at_init_config = ConfigParser.ConfigParser()
        self._at_init_config.read("pcrcontrol.conf")
        if not self._at_init_config.has_section("main"):
        	self._at_init_config.add_section("main")
        self._at_init_config.set("main", "at", str(self.at))
        self._at_init_config.write(open("pcrcontrol.conf", 'w'))
        self._at_chooser.set_value(self.at)

    def get_agc(self):
        return self.agc

    def set_agc(self, agc):
        self.agc = agc
        self.xmlrpc_client_8.set_agc(self.agc)
        self._agc_init_config = ConfigParser.ConfigParser()
        self._agc_init_config.read("pcrcontrol.conf")
        if not self._agc_init_config.has_section("main"):
        	self._agc_init_config.add_section("main")
        self._agc_init_config.set("main", "agc", str(self.agc))
        self._agc_init_config.write(open("pcrcontrol.conf", 'w'))
        self._agc_chooser.set_value(self.agc)

if __name__ == '__main__':
    import ctypes
    import os
    if os.name == 'posix':
        try:
            x11 = ctypes.cdll.LoadLibrary('libX11.so')
            x11.XInitThreads()
        except:
            print "Warning: failed to XInitThreads()"
    parser = OptionParser(option_class=eng_option, usage="%prog: [options]")
    (options, args) = parser.parse_args()
    tb = pcrcontrol()
    tb.Start(True)
    tb.Wait()

